@echo off
rem $URL: http://subversion:8080/svn/gsc/trunk/drivers/INtime/16AIO/16AIO_INtime_4.x_DN/api/mvs15/bmake.bat $
rem $Rev: 43238 $
rem $Date: 2018-07-08 20:49:17 -0500 (Sun, 08 Jul 2018) $

rem 16AIO: MVS 2015: API Library: batch file for buiding the target



rem ===========================================================================
SETLOCAL

set ARG_1=%1
if "%ARG_1%" == "" set ARG_1=all


rem ===========================================================================
:work

set	SOLUTION=16aio_api.sln
set	FILE_1=16aio_api.rsl
set FILE_2=16aio_api.lib

set dir_1=C:\Program Files (x86)\INtime\bin
set dir_2=C:\Program Files\INtime\bin

set src_1="%dir_1%\16aio_api.rsl"
set src_2="%dir_2%\16aio_api.rsl"


set	CFG=Debug^|INtime
set	TRG_1=..\..\lib\mvs15\Debug\%FILE_1%
set	TRG_2=..\..\lib\mvs15\Debug\%FILE_2%
call ..\..\batch\mvs15\_bmake.bat api %ARG_1% %SOLUTION% "%CFG%" %TRG_1% %TRG_2%

set	CFG=Release^|INtime
set	TRG_1=..\..\lib\mvs15\Release\%FILE_1%
set	TRG_2=..\..\lib\mvs15\Release\%FILE_2%
call ..\..\batch\mvs15\_bmake.bat api %ARG_1% %SOLUTION% "%CFG%" %TRG_1% %TRG_2%

if "%ARG_1%" == "clean"		goto clean
if "%ARG_1%" == "status"	goto status
goto end



rem ===========================================================================
:clean

if exist "%dir_1%"	goto clean_1

:clean_2
if		exist %SRC_2%	del %src_2%
if		exist %SRC_2%	echo FAILURE: %SRC_2%
goto end

:clean_1
if		exist %SRC_1%	del %src_1%
if		exist %SRC_1%	echo FAILURE: %SRC_1%
goto end



rem ===========================================================================
:status

if exist "%dir_1%"	goto status_1

:status_2
if		exist %SRC_2% echo SUCCESS: %SRC_2%
if not	exist %SRC_2% echo FAILURE: %SRC_2% ^<-----
goto end

:status_1
if		exist %SRC_1% echo SUCCESS: %SRC_1%
if not	exist %SRC_1% echo FAILURE: %SRC_1% ^<-----
goto end



rem ===========================================================================
:end
:end

ENDLOCAL
