// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/include/16aio_api.h $
// $Rev: 43209 $
// $Date: 2018-07-08 17:26:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: API Library: header file

#ifndef __16AIO_API_H__
#define __16AIO_API_H__

#include <stdlib.h>

#include "16aio.h"



// prototypes *****************************************************************

int	GSC_EXPORT	aio_close(int fd);
int	GSC_EXPORT	aio_init(void);
int	GSC_EXPORT	aio_ioctl(int fd, int request, void *arg);
int	GSC_EXPORT	aio_open(int device, int share, int* fd);
int	GSC_EXPORT	aio_read(int fd, void* dst, size_t bytes);
int	GSC_EXPORT	aio_write(int fd, const void* src, size_t bytes);



#endif
