// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/ai_scan_1_chan.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x00,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x00000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x01,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x01000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x02,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x02000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x03,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x03000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x04,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x04000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x05,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x05000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x06,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x06000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x07,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x07000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x08,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x08000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x09,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x09000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x0A,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x0A000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x0B,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1B000,
			/* value	*/	0x0B000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x0C,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x0C000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x0D,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x0D000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x0E,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x0E000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x0F,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x0F000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x10,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x10000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x11,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x11000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x12,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x12000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x13,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x13000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x14,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x14000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x15,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x15000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x16,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x16000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x17,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x17000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x18,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x18000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x19,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x19000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x1A,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x1A000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x1B,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1B000,
			/* value	*/	0x1B000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x1C,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x1C000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x1D,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x1D000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x1E,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x1E000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_1_CHAN,
			/* arg		*/	0x1F,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x1F000,
			/* value	*/	0x1F000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// Additional equipment is needed to test this feature.
	return(0);
}



/******************************************************************************
*
*	Function:	ai_scan_1_chan_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AI_SCAN_1_CHAN.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_scan_1_chan_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AI_SCAN_1_CHAN");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


