@echo off
rem $URL: http://subversion:8080/svn/gsc/trunk/drivers/INtime/16AIO/16AIO_INtime_4.x_DN/bmake_mvs15.bat $
rem $Rev: 43442 $
rem $Date: 2018-08-26 18:43:05 -0500 (Sun, 26 Aug 2018) $

rem 16AIO: MVS 2015: Overall batch file for buiding MVS 2015 targets.



rem ===========================================================================
SETLOCAL

rem %1 = blank or build target (clean, ...), or BUILD
if "%1" == "BUILD" goto BUILD



rem ===========================================================================

call .\bmake_mvs15.bat BUILD	driver\mvs15				bmake.bat	%1
call .\bmake_mvs15.bat BUILD	api\mvs15					bmake.bat	%1
call .\bmake_mvs15.bat BUILD	docsrc\mvs15				bmake.bat	%1
call .\bmake_mvs15.bat BUILD	utils\mvs15					bmake.bat	%1
call .\bmake_mvs15.bat BUILD	lib\mvs15					bmake.bat	%1

call .\bmake_mvs15.bat BUILD	samples\aithwaitrate\mvs15	bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\aoburst\mvs15		bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\aout\mvs15			bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\auxin\mvs15			bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\auxout\mvs15		bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\din\mvs15			bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\dout\mvs15			bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\driver_mbox\mvs15	bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\exit\mvs15			bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\id\mvs15			bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\laout\mvs15			bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\regs\mvs15			bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\rxrate\mvs15		bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\savedata\mvs15		bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\sbtest\mvs15		bmake.bat	%1
call .\bmake_mvs15.bat BUILD	samples\signals\mvs15		bmake.bat	%1

if		"%1" == "status"	goto end
if not	"%1" == "clean"		echo ==== STATUS ============================================
if not	"%1" == "clean"		call .\bmake_mvs15.bat status
goto end



rem ===========================================================================
:BUILD
set	CWD=%cd%

if not exist "%cd%\%2"		goto DIR
if not exist "%cd%\%2\%3"	goto FILE
cd "%cd%\%2"
call %3 %4
cd %CWD%

goto end



rem ===========================================================================
:DIR
echo ERROR: Directory "%cd%\%2" not found.
goto end



rem ===========================================================================
:FILE
echo ERROR: File "%cd%\%2\%3" not found.
goto end



rem ===========================================================================
:end
:end

ENDLOCAL
