// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/include/16aio_dsl.h $
// $Rev: 43209 $
// $Date: 2018-07-08 17:26:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Document Source Library: header file

#ifndef __16AIO_DSL_H__
#define __16AIO_DSL_H__

#include <stdlib.h>

#include "16aio_api.h"



// prototypes *****************************************************************

int	aio_close_dsl(int fd);
int	aio_init_dsl(void);
int	aio_ioctl_dsl(int fd, int request, void *arg);
int	aio_open_dsl(int index, int share, int* fd);
int	aio_read_dsl(int fd, void* dst, size_t bytes);
int	aio_write_dsl(int fd, const void* src, size_t bytes);



#endif
